using System;
using System.Collections.Generic;


namespace VarekartotekApplication
{
	// definition af "Hoved-programmet" (data og metoder der findes i hovedprogrammet)
	public class VarekartotekConsoleApplication
	{
		// Application objectets memory (datafelter)
		List<Vare> varesamling;

		// opstarts metoden (constructor)
		public VarekartotekConsoleApplication()
		{
			this.varesamling = new List<Vare>();    // opret tom varesamling
			this.OpretTestVarer();			        // fyld data i 
            //this.UdskrivAlleVarer();		        // udskriv

            Vare fVare;
            fVare = this.FindVare(1002);
            this.UdskrivEnVare(fVare);
            fVare.RegistrerVarerIndkbt(10);
            this.UdskrivEnVare(fVare);

			Console.ReadLine();				        // Pause - vent p return !!
		}

		// metode der opretter test varer
		public void OpretTestVarer ()
		{
            varesamling.Add(new Vare(1001, "A4 blok ternet med huller", 10, 3.98f, "kasser", 3.68f, 30, 40, 100));
            varesamling.Add(new Vare(1002, "A4 blok linieret med huller", 20, 3.88f, "boxe", 3.65f, 40, 60, 20));
            varesamling.Add(new Vare(1003, "Blyant Viking 400x2", 110, 0.64f, "sker", 0.50f, 500, 620, 200));
            varesamling.Add(new Vare(1004, "Blyant Viking 800x2", 210, 0.66f, "sker", 0.55f, 410, 615, 200));
        }

        // metode der udskriver en oversigt over alle varer i samlingen
        public Vare FindVare(int sgeVarenr)
        {
            Vare fundetVare = null;
            foreach (Vare enVare in varesamling)
            {
                if (enVare.Varenr == sgeVarenr)
                    fundetVare = enVare;
            }
            return fundetVare;
        }

        // metode der udskriver en oversigt over alle varer i samlingen
        public void UdskrivAlleVarer()
        {
            double totalSalgsvrdi = 0;
            Console.WriteLine("Vare oversigt");
            foreach (Vare enVare in varesamling)
            {
                this.UdskrivEnVare(enVare);
                totalSalgsvrdi += enVare.Salgsvrdi();
            }
            Console.WriteLine("Total salgsvrdi " + totalSalgsvrdi);
        }

        // metode der udskriver en oversigt over alle varer i samlingen
        public void UdskrivVarerMedMinAntalPLager(int minAntal)
        {
            double totalSalgsvrdi = 0;
            Console.WriteLine("Vare oversigt min...");
            foreach (Vare enVare in varesamling)
            {
                if (enVare.AntalPLager < minAntal)
                {
                    this.UdskrivEnVare(enVare);
                    totalSalgsvrdi += enVare.Salgsvrdi();
                }
            }
            Console.WriteLine("Total salgsvrdi " + totalSalgsvrdi);
        }

		// metode der udskriver en enkelt vare, der angives som input-parameter
		public void UdskrivEnVare (Vare vare)
		{
			Console.WriteLine("--------------------------------------------------");
			Console.WriteLine("Varenr: " + vare.Varenr);
			Console.WriteLine("Betegnelse: " + vare.Betegnelse);
			Console.WriteLine("Antal enheder p lager: " + vare.AntalPLager);
			Console.WriteLine("Salgsvrdi: " + vare.Salgsvrdi() );//NB: metodekald
		}
	}
}
