using System;
using System.Collections.Generic;
using System.Text;

namespace VarekartotekWindowsApplication
{
    // definition af Vare (data og metoder der findes for hver enkelt vare-object
    public class Vare
    {
        // vare-objektes memory (datafelter) og tilhrende properties
        // bemrk at objektets memory-variabel er blevet private og navn ndret
        // til lille begyndelsesbogstav
        // Property har det "gamle" navn med stort startbogstav, sledes
        // at der ikke skulle rettes uden for klassen, idet man nu anvender 
        // property i stedet for direkte tilgang til objektes memory variabel
        // I Vare-objektes metoder skal der ndres til memory-variabelen, hvor der
        // ikke tillades lsning eller ndring. Der kan i vare-objeltets metoder
        // desuden ndres til memory-variabelen, hvor der nskes en performanceforbedring.

        private int varenr;
        public int Varenr               // property - kan kun aflses
        {
            get { return varenr; }
        }

        private string betegnelse;
        public string Betegnelse        // property - kan bde afleses og ndres
        {
            get { return betegnelse; }
            set { betegnelse = value; }
        }

        private int antalPLager;
        public int AntalPLager         // property - kan kun aflses direkte
        // ndringer kan ske med metoden for
        {                               // registrering af antal kbte og solgte
            get { return antalPLager; }
        }

        private float salgsEnhedsPris;			// aktuel excl. moms
        public float SalgsEnhedsPris    // property - kan bde afleses og ndres
        {
            get { return salgsEnhedsPris; }
            set { salgsEnhedsPris = value; }
        }

        private float indkbsEnhedsPris;			// aktuel excl. moms
        public float IndkbsEnhedsPris  // property - kan bde afleses og ndres
        {
            get { return indkbsEnhedsPris; }
            set { indkbsEnhedsPris = value; }
        }

        private string enhed;
        public string Enhed             // property - kan bde afleses og ndres
        {
            get { return enhed; }
            set { enhed = value; }
        }
        private int solgtAntal;
        public int SolgtAntal           // property - kan kun aflses direkte
        // ndringer kan ske med metoden for
        {                               // registrering af antal solgte
            get { return solgtAntal; }
        }
        private int indkbtAntal;
        public int IndkbtAntal         // property - kan kun aflses direkte
        // ndringer kan ske med metoden for
        {                               // registrering af antal kbte
            get { return indkbtAntal; }
        }

        private int minimumAntal;
        public int MinimumAntal         // property - kan bde afleses og ndres
        {
            get { return minimumAntal; }
            set { minimumAntal = value; }
        }

        // constructor til brug for skabelse af nyt vare-object
        public Vare(int varenr, string betegnelse, int antalPLager,
                    float salgsEnhedsPris, string enhed, float indkbsEnhedsPris,
                    int solgtAntal, int indkbtAntal, int minimumAntal)
        {
            this.varenr = varenr;
            this.betegnelse = betegnelse;
            this.antalPLager = antalPLager;
            this.salgsEnhedsPris = salgsEnhedsPris;
            this.enhed = enhed;
            this.indkbsEnhedsPris = indkbsEnhedsPris;
            this.solgtAntal = solgtAntal;
            this.indkbtAntal = indkbtAntal;
            this.minimumAntal = minimumAntal;
        }

        // metode for beregning af den salgsvrdien det samlede antal
        public double Salgsvrdi()
        {
            double salgsvrdi = this.AntalPLager * this.SalgsEnhedsPris;
            return salgsvrdi;
        }

        // metode for beregning af den indkbsvrdien det samlede antal
        public double Indkbsvrdi()
        {
            double indkbsvrdi = this.AntalPLager * this.IndkbsEnhedsPris;
            return indkbsvrdi;
        }

        // metode for registreing af et antal solgte enheder af dette vareobjekt
        public void RegistrerVarerSolgt(int antal)
        {
            this.solgtAntal = this.solgtAntal + antal;
            this.antalPLager = this.antalPLager - antal;
        }

        // metode for registreing af et antal indkbte enheder af dette vareobjekt
        public void RegistrerVarerIndkbt(int antal)
        {
            this.indkbtAntal = this.indkbtAntal + antal;
            this.antalPLager = this.antalPLager + antal;
        }
        // metode for "visning" af vareobjekt
        public override string ToString()
        {
            return ""+this.Varenr +";"
                    +this.Betegnelse+";"
                    +this.AntalPLager+";"
                    +this.SalgsEnhedsPris;
        }
    }
}
