using System;
using System.Collections.Generic;
using System.Text;

namespace VarekartotekWindowsApplication
{
    public class Varekartotek
    {
        private List<Vare> varesamling;
        public Varekartotek()
        {
            this.varesamling = new List<Vare>();
        }
        // metode der opretter test varer
        public void OpretTestVarer()
        {
            varesamling.Add(new Vare(1001, "A4 blok ternet med huller", 10, 3.98f, "kasser", 3.68f, 30, 40, 100));
            varesamling.Add(new Vare(1002, "A4 blok linieret med huller", 20, 3.88f, "boxe", 3.65f, 40, 60, 20));
            varesamling.Add(new Vare(1003, "Blyant Viking 400x2", 110, 0.64f, "sker", 0.50f, 500, 620, 200));
            varesamling.Add(new Vare(1004, "Blyant Viking 800x2", 210, 0.66f, "sker", 0.55f, 410, 615, 200));
        }
        public Vare OpretVare(int varenr,
            string betegnelse, string enhed,
            float salgsEnhedsPris,
            float indkbsEnhedsPris)
        {
            Vare nyVare = new Vare(varenr, betegnelse, 0, salgsEnhedsPris, enhed, indkbsEnhedsPris, 0, 0, 100);
            varesamling.Add(nyVare);
            return nyVare;
        }

        public Vare FindVare(int sgeVarenr)
        {
            Vare fundetVare = null;
            foreach (Vare enVare in varesamling)
            {
                if (enVare.Varenr == sgeVarenr)
                    fundetVare = enVare;
            }
            return fundetVare;
        }

        public Vare FindVare(string sgeBetegnelse)
        {
            Vare fundetVare = null;
            foreach (Vare enVare in varesamling)
            {
//                if (enVare.Betegnelse == sgeBetegnelse)
                if (enVare.Betegnelse.Trim().ToUpper() 
                    == sgeBetegnelse.Trim().ToUpper())
                    fundetVare = enVare;
            }
            return fundetVare;
        }


        public List<Vare> HentAlleVarerList()
        {
            List<Vare> fundneVarer = new List<Vare>();
            foreach (Vare enVare in varesamling)
            {
                fundneVarer.Add(enVare);
            }
            return fundneVarer;
        }

        public Vare[] HentAlleVarer()
        {
            return varesamling.ToArray();
        }

        public Vare[] HentAlleUnderMinbeholdning()
        {
            List<Vare> fundneVarer = new List<Vare>();
            foreach (Vare enVare in varesamling)
            {
                if (enVare.AntalPLager < enVare.MinimumAntal)
                    fundneVarer.Add(enVare);
            }
            return fundneVarer.ToArray();
        }


    }
}
