using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace VarekartotekWindowsApplication
{
    public partial class VarekartotekMainForm : Form
    {
        // Application objectets memory (datafelter)
        List<Vare> varesamling;
        private Varekartotek vareKartoteket;
        public VarekartotekMainForm()
        {
            InitializeComponent();
            this.varesamling = new List<Vare>();    // opret tom varesamling
            this.vareKartoteket = new Varekartotek();
            vareKartoteket.OpretTestVarer();
        }


        // metode der udskriver en oversigt over alle varer i samlingen
        public void UdskrivAlleVarer()
        {
            double totalSalgsvrdi = 0;
            Console.WriteLine("Vare oversigt");
            this.txtLog.Text += "Vare oversigt\r\n";
            foreach (Vare enVare in varesamling)
            {
                this.UdskrivEnVare(enVare);
                totalSalgsvrdi += enVare.Salgsvrdi();
            }
            Console.WriteLine("Total salgsvrdi " + totalSalgsvrdi);
            this.txtLog.Text += "Total salgsvrdi " + totalSalgsvrdi+ "\r\n";
        }

        // metode der udskriver en oversigt over alle varer i samlingen
        public void UdskrivVarerMedMinAntalPLager(int minAntal)
        {
            double totalSalgsvrdi = 0;
            Console.WriteLine("Vare oversigt min...");
            foreach (Vare enVare in varesamling)
            {
                if (enVare.AntalPLager < minAntal)
                {
                    this.UdskrivEnVare(enVare);
                    totalSalgsvrdi += enVare.Salgsvrdi();
                }
            }
            Console.WriteLine("Total salgsvrdi " + totalSalgsvrdi);
        }

        // metode der udskriver en enkelt vare, der angives som input-parameter
        public void UdskrivEnVare(Vare vare)
        {
            //Console.WriteLine("--------------------------------------------------");
            //Console.WriteLine("Varenr: " + vare.Varenr);
            //Console.WriteLine("Betegnelse: " + vare.Betegnelse);
            //Console.WriteLine("Antal enheder p lager: " + vare.AntalPLager);
            //Console.WriteLine("Salgsvrdi: " + vare.Salgsvrdi());//NB: metodekald
            //Console.WriteLine("--------------------------------------------------");
            Console.WriteLine(vare.ToString());
            this.txtLog.Text += "Varenr: " + vare.Varenr + "\r\n";
            this.txtLog.Text += "Betegnelse: " + vare.Betegnelse + "\r\n";
            this.txtLog.Text += "Antal enheder p lager: " + vare.AntalPLager + "\r\n";
            this.txtLog.Text += "Salgsvrdi: " + vare.Salgsvrdi() + "\r\n";//NB: metodekald

            this.txtVarenr.Text = vare.Varenr.ToString();
            this.txtBetegnelse.Text = vare.Betegnelse;
            this.txtSalgsenhedspris.Text = vare.SalgsEnhedsPris.ToString("F2");
        }

        private void btnOpretTestVarer_Click(object sender, EventArgs e)
        {
            vareKartoteket.OpretTestVarer();
        }

        private void btnUdskrivAlleVarer_Click(object sender, EventArgs e)
        {
            this.txtLog.Text = this.txtLog.Text + "Hej verden\r\n";
            this.UdskrivAlleVarer();
        }

        private void btnUdskrivAlleUnderMinimum_Click(object sender, EventArgs e)
        {
            this.UdskrivVarerMedMinAntalPLager(25);
        }

        private void btnKbVare_Click(object sender, EventArgs e)
        {
            string txtVarenr = this.txtVarenr.Text.Trim();
            int varenr = int.Parse(txtVarenr);
            string txtAntal = this.txtAntal.Text.Trim();
            int antal = int.Parse(txtAntal);

            Vare enVare;
            enVare = vareKartoteket.FindVare(varenr);
            enVare.RegistrerVarerIndkbt(antal);
            this.UdskrivEnVare(enVare);
        }

        private void btnFindVare_Click(object sender, EventArgs e)
        {
            string txtVarenr = this.txtVarenr.Text.Trim();
            int varenr = int.Parse(txtVarenr);
            Vare enVare;
            enVare = vareKartoteket.FindVare(varenr);
            this.UdskrivEnVare(enVare);
        }

        private void btnFyldVareliste_Click(object sender, EventArgs e)
        {
            this.lstVarer.Items.Clear();
            foreach (Vare enVare in varesamling)
            {
                this.lstVarer.Items.Add(enVare);
            }

        }

        private void lstVarer_SelectedIndexChanged(object sender, EventArgs e)
        {
            Vare valgtVare;
            valgtVare = (Vare)this.lstVarer.SelectedItem;
            this.UdskrivEnVare(valgtVare);
        }
    }
}